Attribute VB_Name = "Module1"
'ARM 
'
Public Const DONGLE_SUCCESS As Long = &H0                                           ' ɹ
Public Const DONGLE_NOT_FOUND As Long = &HF0000001                                  ' δҵָ豸
Public Const DONGLE_INVALID_HANDLE = &HF0000002                                     ' Чľ
Public Const DONGLE_INVALID_PARAMETER = &HF0000003                                  ' 
Public Const DONGLE_COMM_ERROR = &HF0000004                                         ' ͨѶ
Public Const DONGLE_INSUFFICIENT_BUFFER = &HF0000005                                ' ռ䲻
Public Const DONGLE_NOT_INITIALIZED = &HF0000006                                    ' Ʒδʼ (ûPID)
Public Const DONGLE_ALREADY_INITIALIZED = &HF0000007                                ' ƷѾʼ (PID)
Public Const DONGLE_ADMINPIN_NOT_CHECK = &HF0000008                                 ' û֤
Public Const DONGLE_USERPIN_NOT_CHECK = &HF0000009                                  ' ûû֤
Public Const DONGLE_INCORRECT_PIN = &HF000FF00                                      ' 벻ȷ (2λָʾʣ)
Public Const DONGLE_PIN_BLOCKED = &HF000000A                                        ' PIN
Public Const DONGLE_ACCESS_DENIED = &HF000000B                                      ' ʱܾ
Public Const DONGLE_FILE_EXIST = &HF000000E                                         ' ļѴ
Public Const DONGLE_FILE_NOT_FOUND = &HF000000F                                     ' δҵָļ
Public Const DONGLE_READ_ERROR = &HF0000010                                         ' ȡݴ
Public Const DONGLE_WRITE_ERROR = &HF0000011                                        ' дݴ
Public Const DONGLE_FILE_CREATE_ERROR = &HF0000012                                  ' ļļд
Public Const DONGLE_FILE_READ_ERROR = &HF0000013                                    ' ȡļ
Public Const DONGLE_FILE_WRITE_ERROR = &HF0000014                                   ' дļ
Public Const DONGLE_FILE_DEL_ERROR = &HF0000015                                     ' ɾļļд
Public Const DONGLE_FAILED = &HF0000016                                             ' ʧ
Public Const DONGLE_CLOCK_EXPIRE = &HF0000017                                       ' ʱӵ
Public Const DONGLE_ERROR_UNKNOWN = &HFFFFFFFF                                      ' δ֪Ĵ


'ݶ

Public Const CONST_PID = &HFFFFFFFF               'ʱĬPID
Public Const CONST_USERPIN = "12345678"           'ʱĬϵûPIN
Public Const CONST_ADMINPIN = "FFFFFFFFFFFFFFFF"  'ʱĬϵĿPIN

'ͨѶЭ
Public Const PROTOCOL_HID = 0     'hidЭ
Public Const PROTOCOL_CCID = 1    'ccidЭ

'ļ
Public Const FILE_DATA = 1           'ͨļ
Public Const FILE_PRIKEY_RSA = 2     'RSA˽Կļ
Public Const FILE_PRIKEY_ECCSM2 = 3  'ECCSM2˽Կļ(ļṹͬΪһļ)
Public Const FILE_KEY = 4            'SM43DESԿļ
Public Const FILE_EXE = 5            'ִļ

'LED״̬
Public Const LED_OFF = 0    '
Public Const LED_ON = 1     '
Public Const LED_BLINK = 2  '

'PIN
Public Const FLAG_USERPIN = 0    'ûPIN
Public Const FLAG_ADMINPIN = 1   'PIN

'ܱ־
Public Const FLAG_ENCODE = 0   '
Public Const FLAG_DECODE = 1   '

'HASH㷨
Public Const FLAG_HASH_MD5 = 0  'MD5
Public Const FLAG_HASH_SHA1 = 1 'SHA1
Public Const FLAG_HASH_SM3 = 2  'SM3

'Զܺ
Public Const UPDATE_FUNC_CreateFile = 1    'ļ
Public Const UPDATE_FUNC_WriteFile = 2     'дļ
Public Const UPDATE_FUNC_DeleteFile = 3    'ɾļ
Public Const UPDATE_FUNC_FileLic = 4       'ļȨ
Public Const UPDATE_FUNC_SeedCount = 5     '
Public Const UPDATE_FUNC_DownloadExe = 6   'ִļ
Public Const UPDATE_FUNC_UnlockUserPin = 7 'ûPIN
Public Const UPDATE_FUNC_Deadline = 8      'ʱʹ


'RSAԿʽ(10242048)
Public Type RSA_PUBLIC_KEY
    bits                 As Long 'length in bits of modulus
    modulus              As Long 'modulus
    exponent(255)        As Byte 'public exponent
End Type

'RSA˽Կʽ
Public Type RSA_PRIVATE_KEY
    bits                 As Long 'length in bits of modulus
    modulus              As Long 'modulus
    publicExponent(255)  As Byte 'public exponent
    exponent(255)        As Byte 'private exponent
End Type

'ECCSM2Կʽ ECC(֧bitsΪ192256)SM2(bitsΪ̶ֵ0x8100)Կʽ
Public Type ECCSM2_PUBLIC_KEY
    bits           As Long  'length in bits of modulus
    XCoordinate(7) As Long  'ϵX
    YCoordinate(7) As Long  'ϵY
End Type
    
'ⲿECCSM2˽Կʽ ECC(֧bitsΪ192256)SM2(bitsΪ̶ֵ0x8100)˽Կʽ
Public Type ECCSM2_PRIVATE_KEY
    bits           As Long  'length in bits of modulus
    PrivateKey(7)  As Long  '˽Կ
End Type

'Ϣ
Public Type DONGLE_INFO
    m_Ver                As Integer         'COS汾,:0x0201,ʾ2.01
    m_Type               As Integer         'Ʒ: 0xFFʾ׼, 0x00Ϊʱ,0x01ΪʱӵU,0x02Ϊ׼U
    m_BirthDay(7)        As Byte            '
    m_Agent              As Long            '̱,:Ĭϵ0xFFFFFFFF
    m_PID                As Long            'ƷID
    m_UserID             As Long            'ûID
    m_HID(7)             As Byte            '8ֽڵӲID
    m_IsMother           As Long            'ĸ־: 0x01ʾĸ, 0x00ʾĸ
    m_DevType            As Long            '豸(PROTOCOL_HIDPROTOCOL_CCID)
End Type


 '   ļ˵
 '   1.RSA˽ԿļΪ8
 '   2.ECCSM2˽ԿļΪ16
 '   3.3DES/SM4ԿļΪ32
 '   4.ִļΪ64,ܴСܳ64K
 '   5.ļ60.()
 '
'***************************************ļȨṹ****************************************
'ļȨ
Public Type DATA_LIC
    m_Read_Priv  As Integer 'Ȩ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
    m_Write_Priv As Integer 'дȨ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
End Type

'˽ԿļȨṹ
Public Type PRIKEY_LIC
    m_Count      As Long 'ɵ: 0xFFFFFFFFʾ, ݼ0ʾѲɵ
    m_Priv       As Byte 'Ȩ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
    m_IsDecOnRAM As Byte 'Ƿڴеݼ: TRUEΪڴеݼ    FALSEΪFLASHеݼ
    m_IsReset    As Byte 'û̬úǷԶص̬: TRUEΪص̬ (̬ܴ)
    m_Reserve    As Byte ',4ֽڶ
End Type

'ԳƼ㷨(SM4/TDES)ԿļȨṹ
Public Type KEY_LIC
    m_Priv_Enc As Long 'ʱĵȨ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ

End Type

'ִļȨṹ
Public Type EXE_LIC
    m_Priv_Exe As Integer 'еȨ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
    
End Type

'***************************************ļԽṹ'***************************************
'ļݽṹ
Public Type DATA_FILE_ATTR
    m_Size As Long      'ļ
    m_Lic  As DATA_LIC  'Ȩ
End Type


'ECCSM2/RSA˽Կļݽṹ
Public Type PRIKEY_FILE_ATTR
    m_Type As Integer    ':ECCSM2˽Կ  RSA˽Կ
    m_Size As Integer    'ݳ:RSA 1024λ  2048λ, ECC192λ256λ, SM20x8100λ
    m_Lic  As PRIKEY_LIC 'Ȩ
End Type

'ԳƼ㷨(SM4/TDES)Կļݽṹ
Public Type KEY_FILE_ATTR
    m_Size As Long    'Կݳ=16
    m_Lic  As KEY_LIC 'Ȩ
End Type


'ִļݽṹ
Public Type EXE_FILE_ATTR
    m_Lic As EXE_LIC 'Ȩ
    m_Len As Integer 'ļ
End Type

'***************************************ļбṹ'***************************************
'ȡ˽Կļбʱصݽṹ
Public Type PRIKEY_FILE_LIST
    m_FILEID  As Integer          'ļID
    m_Reserve As Integer          ',4ֽڶ
    m_attr    As PRIKEY_FILE_ATTR 'ļ
End Type

'ȡSM4TDESԿļбʱصݽṹ
Public Type KEY_FILE_LIST
    m_FILEID  As Integer       'ļID
    m_Reserve As Integer       ',4ֽڶ
    m_attr    As KEY_FILE_ATTR 'ļ
    
End Type


'ȡļбʱصݽṹ
Public Type DATA_FILE_LIST
    m_FILEID  As Integer        'ļID
    m_Reserve As Integer        ',4ֽڶ
    m_attr    As DATA_FILE_ATTR 'ļ
End Type


'ȡִļбʱصݽṹ
Public Type EXE_FILE_LIST
    m_FILEID  As Integer       'ļID
    m_attr    As EXE_FILE_ATTR '
    m_Reserve As Integer       ',4ֽڶ
End Type


'غпִļʱݽṹ
Public Type EXE_FILE_INFO
    m_dwSize   As Integer   'ִļС
    m_wFileID  As Integer   'ִļID
    m_Priv     As Byte      'Ȩ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
    m_pData    As Long      'ִļݵָ
End Type


'Ҫĳʼ
Public Type SON_DATA
    m_SeedLen         As Long            '볤
    m_SeedForPID(255) As Byte            'ƷIDͿ (250ֽ)
    m_UserPIN(7)      As Byte            'û(16ַ0ַֹ)
    m_UserTryCount    As Byte            'ûԴ
    m_AdminTryCount   As Byte            'Դ
    m_UpdatePriKey    As RSA_PRIVATE_KEY 'Զ˽Կ
    m_UserID_Start    As Long            'ʼûID
End Type


'ĸ
Public Type MOTHER_DATA
    m_Son   As SON_DATA 'ʼ
    m_Count As Long     'ɲʼݵĴ (-1ʾƴ, ݼ0ʱ)
End Type



                                        
'öټ
Public Declare Function Dongle_Enum Lib "NetETARM_Dll" ( _
                                        ByRef pDongleInfo As DONGLE_INFO, _
                                        ByRef pCount As Long) As Long
                                        
'ָļ
Public Declare Function Dongle_Open Lib "NetETARM_Dll" ( _
                                        ByRef phDongle As Long, _
                                        ByVal nIndex As Long) As Long


'PIN֤״̬
Public Declare Function Dongle_ResetState Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long) As Long

'رմ򿪵ļ
Public Declare Function Dongle_Close Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long) As Long



'
Public Declare Function Dongle_GenRandom Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal nLen As Long, _
                                        ByRef pRandom As Byte) As Long
'LEDƵĿƲ
Public Declare Function Dongle_LEDControl Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal nFlag As Long) As Long
                                        

'лͨѶЭ
Public Declare Function Dongle_SwitchProtocol Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal nFlag As Long) As Long
'һָ
Public Declare Function Dongle_RFS Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long) As Long

'ļ
Public Declare Function Dongle_CreateFile Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal nFileType As Long, _
                                       ByVal wFileID As Integer, _
                                       ByRef pFileAttr As Any) As Long

'дļ
Public Declare Function Dongle_WriteFile Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal nFileType As Long, _
                                       ByVal wFileID As Integer, _
                                       ByVal wOffset As Integer, _
                                       ByRef pInData As Byte, _
                                       ByVal nDataLen As Long) As Long
                                       
 'ȡڵļ
Public Declare Function Dongle_ReadFile Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal wFileID As Integer, _
                                       ByVal wOffset As Integer, _
                                       ByRef pOutData As Byte, _
                                       ByVal nDataLen As Long) As Long
                                       

'ؿִļ
Public Declare Function Dongle_DownloadExeFile Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByRef pExeFileInfo As EXE_FILE_INFO, _
                                       ByVal nCount As Long) As Long

'ָڿִг
Public Declare Function Dongle_RunExeFile Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal wFileID As Integer, _
                                       ByRef pInOutData As Byte, _
                                       ByVal wInOutDataLen As Integer, _
                                       ByRef pMainRet As Long) As Long
                                       
'ɾļ
Public Declare Function Dongle_DeleteFile Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal nFileType As Long, _
                                       ByVal wFileID As Integer) As Long


'ļ
Public Declare Function Dongle_ListFile Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal nFileType As Long, _
                                       ByRef pFileList As Any, _
                                       ByRef pDataLen As Integer) As Long
 
'Ψһ
Public Declare Function Dongle_GenUniqueKey Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal nSeedLen As Long, _
                                       ByRef pSeed As Byte, _
                                       ByVal pPIDstr As Any, _
                                       ByVal pAdminPINstr As Any) As Long
'У
Public Declare Function Dongle_VerifyPin Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal nFlags As Long, _
                                       ByVal pPIN As Any, _
                                       ByRef pRemainCount As Long) As Long

'
Public Declare Function Dongle_ChangePIN Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal nFlags As Long, _
                                       ByVal pOldPIN As Any, _
                                       ByVal pNewPIN As Any, _
                                       ByVal nTryCount As Long) As Long
                                       
'ûPIN
Public Declare Function Dongle_ResetUserPIN Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal pAdminPIN As Any) As Long
'ûID
Public Declare Function Dongle_SetUserID Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal dwUserID As Long) As Long
'ȡʱ
Public Declare Function Dongle_GetDeadline Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByRef pdwTime As Long) As Long
                                       
'üʱ
Public Declare Function Dongle_SetDeadline Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByVal pdwTime As Long) As Long
'ȡUTCʱ
Public Declare Function Dongle_GetUTCTime Lib "NetETARM_Dll" ( _
                                       ByVal hDongle As Long, _
                                       ByRef pdwUTCTime As Long) As Long
                                       
                                       
'ݴ洢
Public Declare Function Dongle_ReadData Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal nOffset As Long, _
                                        ByRef pData As Byte, _
                                        ByVal nDataLen As Long) As Long

'дݴ洢
Public Declare Function Dongle_WriteData Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal nOffset As Long, _
                                        ByVal pData As Byte, _
                                        ByVal nDataLen As Long) As Long


'ڴ
Public Declare Function Dongle_ReadShareMemory Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pData As Byte) As Long
'дڴ
Public Declare Function Dongle_WriteShareMemory Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pData As Byte, _
                                        ByVal nDataLen As Integer) As Long
'RSAԿ˽Կ
Public Declare Function Dongle_RsaGenPubPriKey Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal wPriFileID As Integer, _
                                        ByRef pPubBakup As RSA_PUBLIC_KEY, _
                                        ByRef pPriBakup As RSA_PRIVATE_KEY) As Long
'RSA˽Կ
Public Declare Function Dongle_RsaPri Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal wPriFileID As Integer, _
                                        ByVal nFlag As Long, _
                                        ByRef pInData As Byte, _
                                        ByVal nInDataLen As Long, _
                                        ByRef pOutData As Byte, _
                                        ByRef nOutDataLen As Long) As Long
'RSAԿ
Public Declare Function Dongle_RsaPub Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal nFlag As Long, _
                                        ByRef pPubBakup As RSA_PUBLIC_KEY, _
                                        ByRef pInData As Byte, _
                                        ByVal nInDataLen As Long, _
                                        ByRef pOutData As Byte, _
                                        ByRef nOutDataLen As Long) As Long
'ECCԿ˽Կ
Public Declare Function Dongle_EccGenPubPriKey Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal wPriFileID As Integer, _
                                        ByRef pPubBakup As ECCSM2_PUBLIC_KEY, _
                                        ByRef pPriBakup As ECCSM2_PRIVATE_KEY) As Long
'ECC˽Կǩ
Public Declare Function Dongle_EccSign Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal wPriFileID As Integer, _
                                        ByRef pHashData As Byte, _
                                        ByVal nHashDataLen As Long, _
                                        ByRef pOutData As Byte) As Long
'ECCԿǩ
Public Declare Function Dongle_EccVerify Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pPubKey As ECCSM2_PUBLIC_KEY, _
                                        ByRef pHashData As Byte, _
                                        ByVal nHashDataLen As Long, _
                                        ByRef pSign As Byte) As Long
'SM2Կ˽Կ
Public Declare Function Dongle_SM2GenPubPriKey Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal wPriFileID As Integer, _
                                        ByRef pPubBakup As ECCSM2_PUBLIC_KEY, _
                                        ByRef pPriBakup As ECCSM2_PRIVATE_KEY) As Long
'SM2˽Կǩ
Public Declare Function Dongle_SM2Sign Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal wPriFileID As Integer, _
                                        ByRef pHashData As Byte, _
                                        ByVal nHashDataLen As Long, _
                                        ByRef pOutData As Byte) As Long
'SM2Կǩ
Public Declare Function Dongle_SM2Verify Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pPubKey As ECCSM2_PUBLIC_KEY, _
                                        ByRef pHashData As Byte, _
                                        ByVal nHashDataLen As Long, _
                                        ByRef pSign As Byte) As Long
'3DESӽ
Public Declare Function Dongle_TDES Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal wKeyFileID As Integer, _
                                        ByVal nFlag As Long, _
                                        ByRef pInData As Byte, _
                                        ByRef pOutData As Byte, _
                                        ByVal nDataLen As Long) As Long

'SM4ӽ
Public Declare Function Dongle_SM4 Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal wKeyFileID As Integer, _
                                        ByVal nFlag As Long, _
                                        ByRef pInData As Byte, _
                                        ByRef pOutData As Byte, _
                                        ByVal nDataLen As Long) As Long

'HASH
Public Declare Function Dongle_HASH Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal nFlag As Long, _
                                        ByRef pInData As Byte, _
                                        ByVal nInDataLen As Long, _
                                        ByRef pHash As Byte) As Long
'㷨
Public Declare Function Dongle_Seed Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pSeed As Byte, _
                                        ByVal nSeedLen As Long, _
                                        ByRef pOutData As Byte) As Long
                                    
'㷨
Public Declare Function Dongle_LimitSeedCount Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal nCount As Long) As Long
'һĸ
Public Declare Function Dongle_GenMotherKey Lib "NetETARM_Dll" ( _
                                        ByRef hDongle As Long, _
                                        ByRef pInData As MOTHER_DATA) As Long

'ӿȡ
Public Declare Function Dongle_RequestInit Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pRequest As Byte) As Long

'ĸȡڳʼ
Public Declare Function Dongle_GetInitDataFromMother Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pRequest As Byte, _
                                        ByRef pInitData As Byte, _
                                        ByRef pDataLen As Long) As Long

'
Public Declare Function Dongle_InitSon Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pInitData As Byte, _
                                        ByVal nDataLen As Long) As Long
'Զ˽Կ
Public Declare Function Dongle_SetUpdatePriKey Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pPriKey As RSA_PRIVATE_KEY) As Long
                                        
'Զݰ
Public Declare Function Dongle_MakeUpdatePacket Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef phid As Any, _
                                        ByVal nFunc As Long, _
                                        ByVal nFileType As Long, _
                                        ByVal wFileID As Integer, _
                                        ByVal nOffset As Long, _
                                        ByRef pBuffer As Byte, _
                                        ByVal nBufferLen As Long, _
                                        ByRef pUPubKey As RSA_PUBLIC_KEY, _
                                        ByRef pOutData As Byte, _
                                        ByRef pOutDataLen As Long) As Long
'ĸʽԶݰ
Public Declare Function Dongle_MakeUpdatePacketFromMother Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByVal phid As Any, _
                                        ByVal nFunc As Long, _
                                        ByVal nFileType As Long, _
                                        ByVal wFileID As Integer, _
                                        ByVal nOffset As Long, _
                                        ByRef pBuffer As Byte, _
                                        ByVal nBufferLen As Long, _
                                        ByRef pOutData As Byte, _
                                        ByRef pOutDataLen As Long) As Long

'Զ
Public Declare Function Dongle_Update Lib "NetETARM_Dll" ( _
                                        ByVal hDongle As Long, _
                                        ByRef pUpdateData As Byte, _
                                        ByVal nDataLen As Long) As Long

