// TestClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestClient.h"
#include "TestClientDlg.h"
#include "time.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

void  Hex2Str(char* pdst, BYTE* psrc, int leng)
{
	char  table[] = {"0123456789ABCDEF"};
	BYTE  tmb;
	int   ind;
	int   i, j;
	//====================
	for(i=0, j=0; i<leng; i++)
	{
		tmb = psrc[i];
		ind = (tmb>>4)&0x0F;
		pdst[j] = table[ind];
		j ++;
		//
		ind = tmb&0x0F;
		pdst[j] = table[ind];
		j ++;
	}
}

void  DWORD2Str(char*pdx,DWORD dwsrc)
{
	char szBuf[20]={0};
	wsprintf(szBuf,"%08x",dwsrc);
	int i=0;
	for(i=0;i<8;i++)
	{
		if(szBuf[i]>='0' && szBuf[i]<='9') pdx[i]=szBuf[i];
		if(szBuf[i]>='a' && szBuf[i]<='f')pdx[i]=szBuf[i]-0x20;
	}

}
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestClientDlg dialog




CTestClientDlg::CTestClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestClientDlg::IDD, pParent),m_byModNum(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_statusCheck=0;
}

void CTestClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX,IDC_EDIT1,m_byModNum);
	DDX_Control(pDX,IDC_LIST1,m_list);
	DDX_Check(pDX,IDC_CHECK2,m_statusCheck);
}

BEGIN_MESSAGE_MAP(CTestClientDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CTestClientDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON4, &CTestClientDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON2, &CTestClientDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CTestClientDlg::OnBnClickedButton3)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, &CTestClientDlg::OnLvnItemchangedList1)
	ON_BN_CLICKED(IDC_BUTTON5, &CTestClientDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_CHECK2, &CTestClientDlg::OnBnClickedCheck2)
	ON_BN_CLICKED(IDC_BUTTON6, &CTestClientDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CTestClientDlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CTestClientDlg::OnBnClickedButton8)
	ON_BN_CLICKED(IDC_BUTTON9, &CTestClientDlg::OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, &CTestClientDlg::OnBnClickedButton10)
	ON_BN_CLICKED(IDC_BUTTON11, &CTestClientDlg::OnBnClickedButton11)
	ON_BN_CLICKED(IDC_BUTTON12, &CTestClientDlg::OnBnClickedButton12)
END_MESSAGE_MAP()


// CTestClientDlg message handlers

BOOL CTestClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_list.SetExtendedStyle( LVS_EX_FLATSB
		|LVS_EX_FULLROWSELECT
		|LVS_EX_HEADERDRAGDROP
		|LVS_EX_ONECLICKACTIVATE
		|LVS_EX_GRIDLINES);
	m_list.InsertColumn(0,"",LVCFMT_LEFT,80,0);
	m_list.InsertColumn(1,"״̬",LVCFMT_LEFT,80,0);
	m_list.InsertColumn(2,"򿪵ģ",LVCFMT_LEFT,120,0);
	m_list.InsertColumn(3,"PID",LVCFMT_LEFT,80,0);
	


	///ƿؼ
	((CEdit*)(this->GetDlgItem(IDC_EDIT3)))->SetLimitText(16);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestClientDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}





//öټ
void CTestClientDlg::OnBnClickedButton4()
{
	DWORD dwRet=0;
	int Count=0;
	DONGLE_INFO *pKeyInfo=NULL;
	dwRet=Dongle_Enum(NULL,&Count);
	m_list.DeleteAllItems();
	if(dwRet==DONGLE_SUCCESS)
	{
		if(!Count)
		{
			::AfxMessageBox(_T("ûҵ"));
			return;
		}


		pKeyInfo=(DONGLE_INFO*)malloc(Count*sizeof(DONGLE_INFO));
		memset(pKeyInfo,0,sizeof(DONGLE_INFO)*Count);

		dwRet=Dongle_Enum(pKeyInfo,&Count);
		if(dwRet==0)
		{
			//ݼ
			for(int i=0;i<Count;i++)
			{
				CString str1;
				char szPID[50]={0};
				str1.Format(_T("%i"),i);
				m_list.InsertItem(i,"");
				m_list.SetItemText(i,0,str1);
				//Hex2Str(szPID,(BYTE*)&pKeyInfo[i].m_PID,4);
				DWORD2Str(szPID,pKeyInfo[i].m_PID);
				m_list.SetItemText(i,3,szPID);
			}
		}

		free(pKeyInfo);
	}
	else
	{//жϴϢ
		switch(dwRet)
		{
		case DONGLE_FAILED_NET_NOTFINDNETLOCK:
			AfxMessageBox(_T("ûҵõļ"));
			break;
		case R_CONNECTFAILED:
			AfxMessageBox(_T("ӷʧ"));
			break;
		}

	}
}


//
void CTestClientDlg::OnBnClickedButton1()
{

	DWORD dwBegin=0,dwEnd=0;
	DWORD dwRet;


	UpdateData(TRUE);
	dwBegin=GetTickCount();
	//ģ
	if(m_byModNum>63)
	{
		::AfxMessageBox(_T("ȷģ"));
		return;
	}
	//
	dwRet=Dongle_Open(&m_DongleHandle,MAKEDWORD(m_iLockIndex,m_byModNum));
	switch(dwRet)
	{
	case DONGLE_SUCCESS:
		{//ɹ
			CString str1;
			str1.Format(_T("%i"),m_byModNum);
			m_list.SetItemText(m_iLockIndex,1,"");
			m_list.SetItemText(m_iLockIndex,2,str1);

			m_listofDongleHandle.push_back(m_DongleHandle);
		}
		break;
	case DONGLE_FAILED_NET_CONNECTED:
		{//Ѿ
			::AfxMessageBox(_T("Ѿ"));
		}
		break;
	case DONGLE_FAILED_NET_FULL:
		{//
			::AfxMessageBox(_T(""));
		}
		break;
	case DONGLE_FAILED_NET_DENIED:
		{
			::AfxMessageBox(_T("ܾ"));
		}
		break;
	}
	dwEnd=GetTickCount();

	char szShow[255]={0};
	wsprintf(szShow,"ִеʱ:-----------------------%i\n",dwEnd-dwBegin);
	TRACE(szShow);

	
	
	
}



//ر
void CTestClientDlg::OnBnClickedButton2()
{
	DWORD dwRet=0;
	dwRet=Dongle_Close(m_DongleHandle);
	if(dwRet==DONGLE_SUCCESS)
	{
		::AfxMessageBox(_T("ر"));
	}
}

void CTestClientDlg::OnBnClickedButton3()
{//
	//ȡ
	DWORD dwRet=0xFFF;
	BYTE byGenNum[20]={0};
	char buf[255]={0};
	dwRet=Dongle_GenRandom(m_DongleHandle,20,byGenNum);
	switch(dwRet)
	{
	case DONGLE_SUCCESS:
		{//ɹ
			CString str;
			Hex2Str(buf,byGenNum,20);
			this->SetDlgItemText(IDC_EDIT2,buf);
		}
		break;
	case DONGLE_FAILED_NET_NOCONNECTED:
		{//ûн
			::AfxMessageBox(_T("ûн"));
		}
		break;
	}
}

void CTestClientDlg::OnLvnItemchangedList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	m_iLockIndex=pNMLV->iItem;
	*pResult = 0;
}



//УPIN
void CTestClientDlg::OnBnClickedButton5()
{
	char szPIN[20]={0};
	CString szBuf;
	this->GetDlgItemText(IDC_EDIT3,szBuf);

	if(szBuf.IsEmpty())
	{
		::AfxMessageBox(_T("ȷPIN"));
		return;
	}

	strcpy(szPIN,szBuf.GetBuffer(szBuf.GetLength()));
	int RemainCount=0;
	DWORD dwRet=Dongle_VerifyPin(m_DongleHandle,0,szPIN,&RemainCount);
	if(dwRet==0)
	{
		::AfxMessageBox(_T("֤ûPINɹ"));
	}
	else
		::AfxMessageBox(_T("֤ûPINʧ"));
}


//LED
void CTestClientDlg::OnBnClickedCheck2()
{
	CDataExchange dx(this,TRUE);
	DDX_Check(&dx,IDC_CHECK2,m_statusCheck);
	DWORD dwRet=Dongle_LEDControl(m_DongleHandle,m_statusCheck);
}


//ȡļ
void CTestClientDlg::OnBnClickedButton6()
{
	CString szFileID;
	this->GetDlgItemText(IDC_EDIT4,szFileID);

	DWORD dwFileID=::_tcstoul(szFileID.GetBuffer(szFileID.GetLength()), 0, 16);


	UINT fileLen;
	fileLen=this->GetDlgItemInt(IDC_EDIT5);

	BYTE buf[20]={0};

	DWORD dwRet=Dongle_ReadFile(m_DongleHandle,dwFileID,fileLen,buf,20);
	switch(dwRet)
	{
	case DONGLE_SUCCESS:
		{
			char szBuf[200]={0};
			Hex2Str(szBuf,buf,20);
			this->SetDlgItemText(IDC_EDIT6,szBuf);
		}
		break;
	case DONGLE_USERPIN_NOT_CHECK:
		{//ûû֤
			::AfxMessageBox(_T("ûû֤"));
		}
		break;
	case DONGLE_INVALID_PARAMETER:
		{
			::AfxMessageBox(_T(""));
		}
		break;
	case DONGLE_READ_ERROR:
		{
			::AfxMessageBox(_T("ȡݴ"));
		}
		break;
	}

}


//ReadData
void CTestClientDlg::OnBnClickedButton7()
{
	UINT uiOffset=this->GetDlgItemInt(IDC_EDIT7);
	UINT uiLen=this->GetDlgItemInt(IDC_EDIT8);

	if(uiLen>1024 || uiLen<0)
	{
		::AfxMessageBox(_T("ݳֵܴ1024"));
		return;
	}

	BYTE *pBuf=(BYTE*)malloc(uiLen);

	DWORD dwRet=Dongle_ReadData(m_DongleHandle,uiOffset,pBuf,uiLen);
	switch(dwRet)
	{
	case DONGLE_SUCCESS:
		{
			char *pszBuf=(char*)malloc(uiLen*2+1);
			memset(pszBuf,0,uiLen*2+1);
			Hex2Str(pszBuf,pBuf,uiLen);
			this->SetDlgItemText(IDC_EDIT9,pszBuf);
			free(pszBuf);
		}
		break;
	case DONGLE_USERPIN_NOT_CHECK:
		{//ûû֤
			::AfxMessageBox(_T("ûû֤"));
		}
		break;
	case DONGLE_INVALID_PARAMETER:
		{
			::AfxMessageBox(_T(""));
		}
		break;
	}

	free(pBuf);
}


//WriteData
void CTestClientDlg::OnBnClickedButton8()
{
	UINT uiLen=this->GetDlgItemInt(IDC_EDIT11);
	UINT uiOffset=this->GetDlgItemInt(IDC_EDIT10);
	CString str1;
	this->GetDlgItemText(IDC_EDIT12,str1);

	if(uiLen>1024 || uiLen<0)
	{
		::AfxMessageBox(_T("ݳֵܴ1024"));
		return;
	}

	BYTE *pBuf=(BYTE*)malloc(uiLen);

	DWORD dwRet=Dongle_WriteData(m_DongleHandle,uiOffset,(BYTE*)str1.GetBuffer(str1.GetLength()),uiLen);
	switch(dwRet)
	{
	case DONGLE_SUCCESS:
		{
			::AfxMessageBox(_T("дɹ"));
		}
		break;
	case DONGLE_USERPIN_NOT_CHECK:
		{//ûû֤
			::AfxMessageBox(_T("ûû֤"));
		}
		break;
	case DONGLE_INVALID_PARAMETER:
		{
			::AfxMessageBox(_T(""));
		}
		break;
	case DONGLE_WRITE_ERROR:
		{
			::AfxMessageBox(_T("дݴ"));
		}
		break;
	}

	if(pBuf!=NULL)
		free(pBuf);
}


//Seed
void CTestClientDlg::OnBnClickedButton9()
{
	CString strSeed;
	this->GetDlgItemText(IDC_EDIT13,strSeed);
	BYTE outbuf[16]={0};

	DWORD dwRet=Dongle_Seed(m_DongleHandle,(BYTE*)strSeed.GetBuffer(strSeed.GetLength()),strSeed.GetLength(),outbuf);
	switch(dwRet)
	{
	case DONGLE_SUCCESS:
		{
			char *pszBuf=(char*)malloc(40);
			memset(pszBuf,0,40);
			Hex2Str(pszBuf,outbuf,16);
			this->SetDlgItemText(IDC_EDIT14,pszBuf);
			free(pszBuf);
		}
		break;
	case DONGLE_USERPIN_NOT_CHECK:
		{//ûû֤
			::AfxMessageBox(_T("ûû֤"));
		}
		break;
	case DONGLE_INVALID_PARAMETER:
		{
			::AfxMessageBox(_T(""));
		}
		break;
	}
}


//GeTUTCTime
void CTestClientDlg::OnBnClickedButton10()
{
	DWORD dwUTCTime=0;
	DWORD dwRet=Dongle_GetUTCTime(m_DongleHandle,&dwUTCTime);
	struct tm *ptm = NULL;
	int year,mon,day,hour,min,sec;
	if(dwRet==DONGLE_SUCCESS)
	{
		ptm = _gmtime32((const __time32_t *)&dwUTCTime);
		//תΪʱ
		year = ptm->tm_year + 1900;
		mon  = ptm->tm_mon + 1;
		day  = ptm->tm_mday;
		hour = ptm->tm_hour;
		min  = ptm->tm_min;
		sec  = ptm->tm_sec;
		CString strTime=_T("");
		strTime.Format(_T("%04d-%02d-%02d %02d:%02d:%02d"),year, mon, day, hour, min, sec);
		this->SetDlgItemText(IDC_EDIT15,strTime);
	}
	else
		::AfxMessageBox(_T("ִ"));
}


//GetDeadLine
void CTestClientDlg::OnBnClickedButton11()
{
	DWORD dwUTCTime=0;
	DWORD dwRet=Dongle_GetDeadline(m_DongleHandle,&dwUTCTime);
	struct tm *ptm = NULL;
	int year,mon,day,hour,min,sec;
	if(dwRet==DONGLE_SUCCESS)
	{
		CString strTime=_T("");
		if(dwUTCTime==0xFFFFFFFF)
		{
			::AfxMessageBox(_T("ûʱ"));
			return;
		}
		else if(dwUTCTime<=0xFFFF)
		{
			strTime.Format(_T("%dСʱ"), dwUTCTime);
		}
		else
		{
			ptm = _gmtime32((const __time32_t*)&dwUTCTime);
			//תΪʱ
			year = ptm->tm_year + 1900;
			mon  = ptm->tm_mon + 1;
			day  = ptm->tm_mday;
			hour = ptm->tm_hour;
			min  = ptm->tm_min;
			sec  = ptm->tm_sec;
			strTime.Format(_T("%04d-%02d-%02d %02d:%02d:%02d"),year, mon, day, hour, min, sec);
		}
		this->SetDlgItemText(IDC_EDIT16,strTime);
	}
	else
		::AfxMessageBox(_T("ִ"));
}
void CTestClientDlg::OnBnClickedButton12()
{
	//ȡļID
	CString strID;
	this->GetDlgItemText(IDC_EDIT17,strID);

	if(strID.IsEmpty())
	{
		::AfxMessageBox(_T("дȷļID"));
		return;
	}

	WORD wID=0;
	wID=_tcstoul(strID.GetBuffer(strID.GetLength()),0,16);

	BYTE buffer[12] = {0x0A,0x00,0x12,0x34,0x00,0x77,0x99,0x13,0x35,0x23,0x23,0x11};
	CString sResult=_T("");
	int rMain=0;
	DWORD dwRet=Dongle_RunExeFile(m_DongleHandle,wID,buffer,12,&rMain);
	if(dwRet==0)
	{
		for(int i=0;i<12;i++)
		{
			CString strTemp;
			strTemp.Format(_T("%02x"),*(buffer+i));
			strTemp+=_T(" ");
			sResult+=strTemp;
		}

		this->SetDlgItemText(IDC_EDIT18,sResult);

	}
	else
	{
		CString strError;
		strError.Format(_T("ش:0x%08x"),dwRet);
		this->SetDlgItemText(IDC_EDIT18,strError);
	}
	
}
